using System;
using System.Collections;
using System.Text;

namespace NUnit.Extensions.Converter
{
	public class CollectionConverter : SpecificObjectConverter
	{
		public CollectionConverter(Converter converter) : base(converter)
		{
		}
		protected override bool CanConvertSelf(object o)
		{
			return o is ICollection;
		}
		protected override object ConvertSelf(object o)
		{
			ICollection collection = (ICollection)o;
			StringBuilder buf = new StringBuilder();
			buf.Append("[");
			if (0 < Context.ExpansionLevel) {
				Context.BeginExpansion();
				bool isEmpty = true;
				foreach (object element in collection) 
				{
					String str = DelegateToString(element);
					if (IsVisible(str)) 
					{
						buf.Append(Environment.NewLine);
						buf.Append(Context.Indent);
						buf.Append(str);
						isEmpty = false;
					}
				}
				if (isEmpty) {
					buf.Append(Environment.NewLine);
					buf.Append(Context.Indent);
					buf.Append("(empty)");
				}
				Context.EndExpansion();
				buf.Append(Environment.NewLine);
				buf.Append(Context.Indent);
			}
			else {
				bool isEmpty = true;
				foreach (object element in collection) {
					String str = DelegateToString(element);
					if (IsVisible(str)) {
						if (!isEmpty)
							buf.Append(", ");
						else
							isEmpty = false;
						buf.Append(str);
					}
				}
				if (isEmpty)
					buf.Append("(empty)");
			}
			buf.Append("]");
			return buf.ToString();
		}
	}
}
