using System;

namespace NUnit.Extensions.Converter
{
	abstract public class ConverterDecorator : Converter
	{
		protected Converter converter;
		public ConverterDecorator(Converter converter)
		{
			this.converter = converter;
			SetOutermostConverter(this);
		}
		public override void SetOutermostConverter(Converter outermostConverter)
		{
			base.SetOutermostConverter(outermostConverter);
			converter.SetOutermostConverter(outermostConverter);
		}
		public override string ToString(object o)
		{
			return converter.ToString(o);
		}
		public override int ExpansionLevel
		{
			set { converter.ExpansionLevel = value; }
		}
		public override ConverterContext Context
		{
			get { return converter.Context; }
		}
	}
}
