using System;
using System.Reflection;

namespace NUnit.Extensions.Converter.Evaluators
{
	public class Beans
	{
		public static object GetPropertyValue(object bean, String name)
		{
			Type type = bean.GetType();
			PropertyInfo propInfo = type.GetProperty(name);
			if (propInfo != null) {
				return propInfo.GetValue(bean, null);
			}
			FieldInfo fieldInfo = type.GetField(name);
			if (fieldInfo != null) {
				return fieldInfo.GetValue(bean);
			}
			MethodInfo methodInfo = type.GetMethod(name);
			if (methodInfo != null) {
				return methodInfo.Invoke(bean, null);
			}
			throw new ArgumentException(type.Name + " does not have " + name + " property.");
		}
		public static string[] GetPropertyNames(object bean)
		{
			Type type = bean.GetType();
			BindingFlags flags = BindingFlags.Instance | BindingFlags.Public;
			PropertyInfo[] propInfos = type.GetProperties(flags);
			FieldInfo[] fieldInfos = type.GetFields(flags);
			string[] result = new string[propInfos.Length + fieldInfos.Length];
			for (int i = 0; i < propInfos.Length; ++i) {
				result[i] = propInfos[i].Name;
			}
			for (int i = 0; i < fieldInfos.Length; ++i) 
			{
				result[propInfos.Length + i] = fieldInfos[i].Name;
			}
			Array.Sort(result);
			return result;
		}
	}
}
