using System;
using System.Collections;
using NUnit.Extensions.Converter;

namespace NUnit.Extensions.Converter.Evaluators
{
	public class SortEvaluator : Evaluator
	{
		private Hashtable keys = new Hashtable();
		public SortEvaluator(params object[] keys)
		{
			foreach (string key in keys)
			{
				this.keys.Add(key, true);
			}
		}
		public override object Evaluate(object o, object key)
		{
			Sorter sorter = new Sorter(converter);
			if (keys.Count == 0 || keys.Contains(key)) 
			{
				return sorter.Sort(o);
			}
			return o;
		}
	}
}
