using System;

namespace NUnit.Extensions.Converter
{
	public abstract class SpecificObjectConverter : ConverterDecorator
	{
		protected SpecificObjectConverter(Converter converter) : base(converter)
		{
		}
		public override string ToString(object o)
		{
			if (CanConvertSelf(o)) {
				object converted;
				try {
					converted = ConvertSelf(o);
				} 
				catch (Exception e) {
					converted = e;
				}
				return DelegateToString(converted);
			}
			return base.ToString(o);
		}
		abstract protected bool CanConvertSelf(object o);
		abstract protected object ConvertSelf(object o);
	}
}
